<template>
  <cabinet-layout nav-active="price">
    <div
      slot="block-content"
      class="priceUpload">
      <submenu
        menu-active="price-upload"
        item-active="template"/>

      <!--Выводить блок когда еще нет ни одного шаблона-->
      <div
        v-if="!hasTemplate && !isChangeTemplate"
        class="priceUpload-content">
        <div class="heading _h1">Шаблоны прайсов</div>
        <div class="priceUpload-info">
          <div class="priceUpload-info-text">Вы пока не создали ни одного шаблона</div>
          <AppButton
            :classes="['_blue', 'buttonCallTemplate']"
            @click.native="callTemplate('new')">
            <template #button-item>
              <img
                svg-inline
                src="~/assets/svg/redesign/plus.svg">
              Создать шаблон
            </template>
          </AppButton>
          <div class="paragraph">
            Шаблоны помогут вам загружать любые прайсы в едином формате,
            а нам - корректно показывать их вашим покупателям.
          </div>
          <div class="paragraph">
            Вы можете создавать отдельные шаблоны, например, для оптовых и розничных прайсов, по производителям и т.д.
          </div>
        </div>
      </div>

      <!--Выводить блок с таблицей, когда есть загрузки-->
      <div
        v-if="hasTemplate && !isChangeTemplate"
        class="priceUpload-content">
        <div class="heading _h1">Шаблоны прайсов</div>
        <div class="priceUpload-table">
          <div class="priceUpload-table-header">
            <AppButton
              :classes="['_blue', 'buttonNewTemplate']"
              @click.native="callTemplate('new')">
              <template #button-item>
                <img
                  svg-inline
                  src="~/assets/svg/redesign/plus.svg">
                Создать новый шаблон
              </template>
            </AppButton>
            <!--для примера. удалить кнопку и модалку!!!!-->
            <button
              class="button"
              @click="callModalTemplate">Новый шаблон в модалке</button>

            <AppModalPriceTemplate
              v-scroll-lock="hasModalTemplate"
              :visible="hasModalTemplate"
              @before-close="hasModalTemplate = false"/>
          </div>

          <AppTable
            class="tablePriceTemplate"
            :table-headings="$options.headings"
            :grid="grid">
            <!-- Ячейки с данными для таблицы -->

            <template
              :slot="`unit-${$options.headings[0].name}`"
              slot-scope="{ part }">
              {{ part.id }}
            </template>
            <template
              :slot="`unit-${$options.headings[1].name}`"
              slot-scope="{ part }">
              01.07.2019
            </template>
            <template
              :slot="`unit-${$options.headings[2].name}`"
              slot-scope="{ part }">
              WarehouseProAuto (под заказ из ОАЭ) 23.10.2018).xlsx
            </template>
            <template
              :slot="`unit-${$options.headings[3].name}`"
              slot-scope="{ part }">
              <AppCheckboxToggle/>
            </template>
            <template
              :slot="`unit-${$options.headings[4].name}`"
              slot-scope="{ part }">
              Новые
            </template>
            <template
              :slot="`unit-${$options.headings[5].name}`"
              slot-scope="{ part }">
              <!--текст, когда невозможно отобразить данные-->
              <span>Отображение формата шаблона недоступно для файлов XML</span>
              <ul class="listInfo">
                <li
                  v-for="(item, index0) in 5"
                  :key="index0"
                  class="listInfo-item">столбец-{{ item }}</li>
                <li class="listInfo-item">
                  <button class="buttonMore">
                    Развернуть все
                  </button>
                </li>
              </ul>
            </template>
            <template
              :slot="`unit-${$options.headings[6].name}`"
              slot-scope="{ part }">
              <ul class="listInfo">
                <li
                  v-for="(item, index1) in 2"
                  :key="index1"
                  class="listInfo-item">
                  <span v-if="false">price-{{ item }}.xlsx</span>
                  <flink
                    v-else
                    href="#"
                    class="link">price-{{ item }}.xlsx
                  </flink>
                </li>
              </ul>
            </template>
            <template
              :slot="`unit-${$options.headings[7].name}`"
              slot-scope="{ part }">
              <button
                class="buttonIcon"
                @click="callTemplate('edit')"
                v-tooltip="{
                  classes: 'tooltipWhite tooltipPriceAction',
                  trigger: 'hover',
                  offset: '12',
                  placement: 'top-end',
                  content: 'Редактировать',}">
                <img
                  svg-inline
                  src="~/assets/svg/redesign/price-edit.svg">
              </button>
              <button
                class="buttonIcon"
                v-tooltip="{
                  classes: 'tooltipWhite tooltipPriceAction',
                  trigger: 'hover',
                  offset: '12',
                  placement: 'top-end',
                  content: 'Копировать',}">
                <img
                  svg-inline
                  src="~/assets/svg/redesign/price-copy.svg">
              </button>
              <AppPopover
                :options="{
                  placement: 'bottom-end',
                  offset: '8',
                  trigger: 'click',
                  additionalClasses: ['tooltipButtonBack', 'tooltipWhite']}">
                <template slot="tooltip-trigger">
                  <button
                    class="buttonIcon"
                    v-tooltip="{
                      classes: 'tooltipWhite tooltipPriceAction',
                      trigger: 'hover',
                      offset: '12',
                      placement: 'top-end',
                      content: 'Удалить',}">
                    <img
                      svg-inline
                      src="~/assets/svg/redesign/price-delete.svg">
                  </button>
                </template>
                <div
                  class="tooltip-content"
                  slot="tooltip-content">
                  <div class="tooltip-text">Удалить шаблон?</div>
                  <button
                    class="button _blue"
                    v-close-popover>Нет</button>
                  <button
                    class="button buttonOutline"
                    v-close-popover>Да</button>
                </div>
              </AppPopover>
            </template>
          </AppTable>
        </div>
      </div>

      <!--Выводить блок, когда вызвано создание/редактирование шаблона-->
      <div
        v-if="isChangeTemplate"
        class="priceUpload-content">
        <div class="priceUpload-back">
          <AppPopover
            :options="{
              placement: 'right',
              offset: '16',
              trigger: 'click',
              additionalClasses: ['tooltipButtonBack', 'tooltipWhite']}">
            <template slot="tooltip-trigger">
              <button
                class="buttonBack">
                <img
                  svg-inline
                  src="~/assets/svg/redesign/button-arrow-right.svg">
                <span class="link">Назад к списку шаблонов</span>
              </button>
            </template>
            <div
              class="tooltip-content"
              slot="tooltip-content">
              <div class="tooltip-text">Сохранить изменения?</div>
              <button
                class="button _blue"
                @click="closeTemplate()"
                v-close-popover>Да</button>
              <button
                class="button buttonOutline"
                @click="closeTemplate()"
                v-close-popover>Нет</button>
            </div>
          </AppPopover>
        </div>

        <PriceTemplate
          :template-type="templateType"/>

      </div>
    </div>
  </cabinet-layout>
</template>

<script>
import CabinetLayout from '~/components/redesign/cabinet/main-layout';
import Submenu from '~/components/redesign/cabinet/submenu';
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppInputRadio from '~/components/redesign/app-input/app-input-radio';
import AppTable from '~/components/redesign/app-table/app-table';
import AppModalPriceTemplate from '~/components/redesign/app-modals/app-modal-price-template';

import { priceTemplate as Headings } from '~/assets/js/mocks/table/headings';
import AppPopover from '~/components/redesign/app-tooltip/app-popover';
import PriceTemplate from '~/components/redesign/cabinet/price-upload/price-template';
import AppCheckboxToggle from '~/components/redesign/app-input/app-checkbox-toggle';

export default {
  name: 'PriceUploadTemplate',
  components: {
    AppCheckboxToggle,
    PriceTemplate,
    AppModalPriceTemplate,
    AppPopover,
    AppTable,
    AppInputRadio,
    AppButton,
    CabinetLayout,
    Submenu,
  },
  layout: 'cabinet',
  data() {
    return {
      hasTemplate: true,
      hasModalTemplate: false,
      isChangeTemplate: false,
      templateType: 'new',
      grid: {
        data: [
          {
            id: 0,
            data: '10.10.2020',
          },
          {
            id: 1,
            data: '10.10.2020',
          },
          {
            id: 2,
            data: '10.10.2020',
          },
        ],
      },
    };
  },
  computed: {},
  created() {
    this.$options.headings = Headings;
  },
  methods: {
    callTemplate(type) {
      this.templateType = type;
      this.isChangeTemplate = true;
    },
    closeTemplate() {
      this.isChangeTemplate = false;
    },
    callModalTemplate() {
      this.hasModalTemplate = true;
    },
  },
};
</script>

<style lang="postcss">
  @import "~/assets/css/components/price-upload-pages.css";
</style>
